----------------------------------------------------------------
--Memory Core Generated By "Altium Core Generator" Version 1.0.0
--TimeStamp 2008 9 12 14 43 19)
----------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY altera_mf;
USE altera_mf.altera_mf_components.all;

ENTITY Memory_M_MDU IS
    PORT
    (
        DINA      : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
        WEA       : IN STD_LOGIC  := '1';
        ADDRA     : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
        DINB      : IN STD_LOGIC_VECTOR (11 DOWNTO 0);
        ADDRB     : IN STD_LOGIC_VECTOR (9 DOWNTO 0);
        WEB       : IN STD_LOGIC  := '1';
        CLKA      : IN STD_LOGIC;
        CLKB      : IN STD_LOGIC;
        DOUTA     : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
        DOUTB     : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
    );
END Memory_M_MDU;


ARCHITECTURE SYN OF Memory_M_MDU IS

    SIGNAL sub_wire0 : STD_LOGIC_VECTOR (11 DOWNTO 0);
    SIGNAL sub_wire1 : STD_LOGIC_VECTOR (11 DOWNTO 0);



    COMPONENT altsyncram
    GENERIC (
             intended_device_family     : STRING;
             operation_mode             : STRING;
             width_a                    : NATURAL;
             widthad_a                  : NATURAL;
             numwords_a                 : NATURAL;
             width_b                    : NATURAL;
             widthad_b                  : NATURAL;
             numwords_b                 : NATURAL;
             lpm_type                   : STRING;
             width_byteena_a            : NATURAL;
             width_byteena_b            : NATURAL;
             outdata_reg_a              : STRING;
             outdata_aclr_a             : STRING;
             outdata_reg_b              : STRING;
             indata_aclr_a              : STRING;
             wrcontrol_aclr_a           : STRING;
             address_aclr_a             : STRING;
             indata_reg_b               : STRING;
             address_reg_b              : STRING;
             wrcontrol_wraddress_reg_b  : STRING;
             indata_aclr_b              : STRING;
             wrcontrol_aclr_b           : STRING;
             address_aclr_b             : STRING;
             outdata_aclr_b             : STRING;
             ram_block_type             : STRING
            );
    PORT   (
             wren_a    : IN STD_LOGIC;
             clock0    : IN STD_LOGIC;
             wren_b    : IN STD_LOGIC;
             clock1    : IN STD_LOGIC;
             address_a : IN STD_LOGIC_VECTOR  (9 DOWNTO 0);
             address_b : IN STD_LOGIC_VECTOR  (9 DOWNTO 0);
             q_a       : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
             q_b       : OUT STD_LOGIC_VECTOR (11 DOWNTO 0);
             data_a    : IN STD_LOGIC_VECTOR  (11 DOWNTO 0);
             data_b    : IN STD_LOGIC_VECTOR  (11 DOWNTO 0)
        );
    END COMPONENT;

BEGIN
    DOUTA <= sub_wire0(11 DOWNTO 0);
    DOUTB <= sub_wire1(11 DOWNTO 0);

    altsyncram_component : altsyncram
    GENERIC MAP (
                intended_device_family=> "CYCLONE III",
                operation_mode        => "BIDIR_DUAL_PORT",
                width_a               => 12,
                widthad_a             => 10,
                numwords_a            => 1024,
                width_b               => 12,
                widthad_b             => 10,
                numwords_b            => 1024,
                lpm_type              => "altsyncram",
                width_byteena_a       => 1,
                width_byteena_b       => 1,
                outdata_reg_a         => "UNREGISTERED",
                outdata_reg_b         => "UNREGISTERED",
                outdata_aclr_a        => "NONE",
                outdata_aclr_b        => "NONE",
                indata_aclr_a         => "NONE",
                wrcontrol_aclr_a      => "NONE",
                address_aclr_a        => "NONE",
                indata_reg_b          => "CLOCK1",
                address_reg_b         => "CLOCK1",
                wrcontrol_wraddress_reg_b => "CLOCK1",
                indata_aclr_b         => "NONE",
                wrcontrol_aclr_b      => "NONE",
                address_aclr_b        => "NONE",
                ram_block_type        => "AUTO"
                )
    PORT MAP   (
                wren_a    => WEA,
                clock0    => CLKA,
                wren_b    => WEB,
                clock1    => CLKB,
                address_a => ADDRA,
                address_b => ADDRB,
                data_a    => DINA,
                data_b    => DINB,
                q_a       => sub_wire0,
                q_b       => sub_wire1
               );



END SYN;
